if not srb2p return end
freeslot("sfx_frhit", "sfx_frcnfrm1", "sfx_frcnfrm2", "sfx_fritem", "sfx_frheal", "sfx_frhslf", "sfx_fr1mre", "sfx_frdodg", "sfx_frwin", "sfx_frmiss", "sfx_frcrit", "sfx_frask1", "sfx_frask2", "sfx_frask3", "sfx_frdo1", "sfx_frdo2", "sfx_frlnt1", "sfx_frlnt2")

VFX_freeslotC("frank")
charStats["frank"] = {

		name = "Frank",		
		basehp = 55,			
		basesp = 30,			
		persona = "frank",		
		melee_natk = "frankpress",	
		
		atk = 35,	
		acc = 90,	
		crit = 3,	
		wep = "franksneak",
		weptype = WPT_SHOES,

		anim_stand = 		{SPR_PLAY, A, 8, "SPR2_STND"},		
		anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_STND"},		
		anim_stand_bored =	{SPR_PLAY, A, B, C, D, A, B, C, D, 10, "SPR2_WAIT"},
		anim_guard = 		{SPR_PLAY, A, 1, "SPR2_TRNS"},
		anim_move =			{SPR_PLAY, A, B, C, D, E, F, G, H, 3, "SPR2_WALK"},
		anim_run =			{SPR_PLAY, A, B, 2, "SPR2_RUN_"},
		anim_atk =			{SPR_PLAY, A, B, C, D, 1, "SPR2_ROLL"},
		anim_aoa_end =		{SPR_PLAY, A, 1, "SPR2_BNCE"},
		anim_hurt =			{SPR_PLAY, A, 20, "SPR2_PAIN"},	
		anim_getdown =		{SPR_PLAY, A, 1, "SPR2_SHIT"},	
		anim_downloop =		{SPR_PLAY, A, 1, "SPR2_SHIT"},
		anim_getup =		{SPR_PLAY, A, B, C, D, 1, "SPR2_ROLL"},
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},
		anim_revive =		{SPR_PLAY, A, B, C, D, 2, "SPR2_CLMB"},
		anim_evoker =		{SPR_PLAY, A, 1, "SPR2_WAIT"},
		anim_evoker_shoot =	{SPR_PLAY, A, B, C, D, 2, "SPR2_SPIN"},
		anim_stand_super = 	{SPR_PLAY, A, 4, "SPR2_STND"},
		anim_stand_hurt_super = 	{SPR_PLAY, A, 4, "SPR2_STND"},
		anim_stand_bored_super = 	{SPR_PLAY, A, B, C, D, 4, "SPR2_WAIT"},
		anim_run_super = 	{SPR_PLAY, A, B, 2, "SPR2_RUN_"},
		anim_evoker_super = 	{SPR_PLAY, A, 4, "SPR2_STND"},
		anim_evoker_shoot_super = 	{SPR_PLAY, A, 4, "SPR2_STND"},
		anim_special1 = {SPR_PLAY, A, 1, "SPR2_BNCE"}, // pound 
		anim_special2 = {SPR_PLAY, A, B, C, D, E, F, G, H, I, J, K, L, M, N, A, B, C, D, E, F, G, H, I, J, K, L, M, N, 4, "SPR2_CLNG"},
		anim_special3 = {SPR_PLAY, A, 1, "SPR2_ROST"},

		vfx_summon = {},
        vfx_skill = {"sfx_frcnfrm1", "sfx_frcnfrm2"},
        vfx_item = {"sfx_fritem"},
        vfx_hurt = {"sfx_frhit"},
        vfx_hurtx = {"sfx_frhit"},
        vfx_die = {"sfx_frhit", "sfx_frhit", "sfx_frhit", "sfx_frhit", "sfx_frhit", "sfx_frhit", "sfx_frhit", "sfx_frhit", "sfx_frcoun", "sfx_frtaco"},
        vfx_heal = {"sfx_frheal"},
        vfx_healself = {"sfx_frheal"},
        vfx_kill = {"sfx_frcnfrm2"},
        vfx_1more = {"sfx_fr1mre", "sfx_frstmp"},	
        vfx_crit = {"sfx_frcrit"},
        vfx_aoaask = {"sfx_frask1", "sfx_frask2", "sfx_frask3"},
        vfx_aoado = {"sfx_frdo1", "sfx_frdo2"},
        vfx_aoarelent = {"sfx_frlnt1", "sfx_frlnt2"},
        vfx_miss = {"sfx_frmiss"},
        vfx_dodge = {"sfx_frdodg", "sfx_frhorn"},	
        vfx_win = {"sfx_frwin", "sfx_fadwow"},
        vfx_levelup = {"sfx_frwin", "sfx_fadwow"},
		vfx_tartarus_pit = {"sfx_frpit"}, // AAAAAAAA

		icon = "ICO_FRNK",	
		hudbust = "FRN_H",	
		hudaoa = "H_FRNAOA",
		hudcutin = "FRNK_A",
		hudspr = "FRNK",
		aoa_quote = "Alright, let's wrap \nthis up!",
		tip = "Can learn Physical and Piercing attacks\nalong with Wind and Psychic attacks.\n Despite having no persona, Frank's\nstats are all-around.",
}			  


personaList["frank"] = {
		name = "frank",
		arcana = ARCANA_FOOL,
		sprite = SPR_PSN0,		
		startframe = 0,			
		anim_idle = 	{SPR_NULL, A},
		anim_atk = 		{SPR_NULL, A},	

		strength = 8,
		magic = 7,
		endurance = 6,
		luck = 5,
		agility = 8,
		weak = ATK_ICE|ATK_CURSE,
		resist = ATK_WIND|ATK_PSY,

		skills = {
					{"lunge", 1}, {"snap", 5}, {"garu", 10},
					{"counter", 12}, {"psi", 13}, 
					{"magaru", 16, "garu"}, {"mapsi", 20, "psi"}, 
					{"hard knuckle", 25}, 

					{"frankdance", 30, "snap"},
					{"counterstrike", 32, "counter"},
					{"sonic punch", 35, "lunge"},
					{"mapsio", 40, "mapsi"},
					{"magarula", 43, "magaru"},
					{"iron fist", 48, "hard knuckle"},

					{"garudyne", 51, "garula"},
					{"psiodyne", 58, "mapsio"},
					{"magarudyne", 60, "magarula"},
					{"delay", 63, "counterstrike"},
					{"gigantic fish", 65},
					{"road roller", 69}, //funny moment
					{"panta rhei", 80, "garudyne"},
				},
}

local jdust = function(inflictor, ns, item)
	local i = 0
	while i < 16
		local fa = (i*(ANGLE_180/8))
		local mo = P_SpawnMobj(inflictor.x, inflictor.y, inflictor.z, item)
		mo.scale = inflictor.scale
		if mo and mo.valid
			mo.momy = FixedMul(cos(fa), ns)
			mo.momx = FixedMul(sin(fa), ns)
		end
		i = $+1
	end
end

attackDefs["frankpress"] = {
		name = "Ground Bounce",
		type = ATK_STRIKE,
		power = 50,
		accuracy = 100,
		critical = 5,
		target = TGT_ENEMY,
		costtype = CST_HP,
		cost = 0,
		desc = "A hard dive and bounce\n on the enemy.",
		anim_norepel = true,
		physical = true,
		anim = function(mo, targets, hittargets, timer)
					local target = targets[1]
					local atarget = hittargets[1]
					if timer == 1
						ANIM_set(mo, mo.anim_move, true)
						mo.reachedtarget = false
						mo.canjump = true
						mo.dover = true
						local an = target.angle + 45*ANG1

						local cx = target.x + 384*cos(an)
						local cy = target.y + 384*sin(an)

						CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, server.P_BattleStatus[mo.battlen].cam.z, 70*FRACUNIT)
						CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y), ANG1*4)
						S_StartSound(mo, sfx_zoom)
					end
					
					if not mo.reachedtarget
						mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
						P_InstaThrust(mo, mo.angle, FRACUNIT*13)
						if R_PointToDist2(mo.x, mo.y, target.x, target.y) < FRACUNIT*300 //jump.
						and mo.canjump
							mo.canjump = false
							mo.momz = 12*FRACUNIT
							ANIM_set(mo, mo.anim_atk, true)
							S_StartSound(mo, sfx_jump)
						end
						if R_PointToDist2(mo.x, mo.y, target.x, target.y) < FRACUNIT*70 //dive,
						and mo.dover
							mo.dover = false
							mo.momz = -20*FRACUNIT
							S_StartSound(mo, sfx_cdfm62)
						end
						
						if mo.dover == false
							local divetrail = P_SpawnGhostMobj(mo)
							divetrail.color = mo.color
							divetrail.colorized = true
							divetrail.fuse = 1
							if mo.momz < 0
								P_SpawnGhostMobj(divetrail)
							end
						end
				
						if R_PointToDist2(mo.x, mo.y, target.x, target.y) < FRACUNIT*10 //bounce!
							ANIM_set(mo, mo.anim_special1, true)
							jdust(mo, 12*mo.scale, MT_DUST)
							mo.reachedtarget = true
							P_InstaThrust(mo, mo.angle, -FRACUNIT*7)
							mo.momz = 8*FRACUNIT
							damageObject(atarget)
							P_StartQuake(FRACUNIT*7, 4)
							playSound(mo.battlen, sfx_phys)
							S_StartSound(mo, sfx_frbnce)
							for i = 1, 2
								createSplat(mo)
							end
						end
					elseif (timer >= 50)
					and mo.momz < -8*FRACUNIT
						return true
					end
				end,
		critanim = function(mo, targets, hittargets, timer)
					local target = targets[1]
					local atarget = hittargets[1]
					if timer == 1
						ANIM_set(mo, mo.anim_move, true)
						mo.reachedtarget = false
						mo.canjump = true
						mo.dover = true
						local an = target.angle + 45*ANG1

						local cx = target.x + 384*cos(an)
						local cy = target.y + 384*sin(an)

						CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, server.P_BattleStatus[mo.battlen].cam.z, 70*FRACUNIT)
						CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y), ANG1*4)
						S_StartSound(mo, sfx_zoom)
					end
					
					if not mo.reachedtarget
						mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
						P_InstaThrust(mo, mo.angle, FRACUNIT*16)
						if R_PointToDist2(mo.x, mo.y, target.x, target.y) < FRACUNIT*300 //MEGA jump.
						and mo.canjump
							mo.canjump = false
							mo.momz = 15*FRACUNIT
							ANIM_set(mo, mo.anim_atk, true)
							S_StartSound(mo, sfx_bigjmp)
						end
						if R_PointToDist2(mo.x, mo.y, target.x, target.y) < FRACUNIT*70 //dive,
						and mo.dover
							mo.dover = false
							mo.momz = -30*FRACUNIT
							S_StartSound(mo, sfx_kc3c)
						end
						
						if mo.dover == false
							local divetrail = P_SpawnGhostMobj(mo)
							divetrail.color = mo.color
							divetrail.colorized = true
							divetrail.fuse = 1
							if mo.momz < 0
								P_SpawnGhostMobj(divetrail)
							end
						end
				
						if R_PointToDist2(mo.x, mo.y, target.x, target.y) < FRACUNIT*10 // MEGA bounce!
							ANIM_set(mo, mo.anim_special1, true)
							jdust(mo, 12*mo.scale, MT_DUST)
							mo.reachedtarget = true
							P_InstaThrust(mo, mo.angle, -FRACUNIT*9)
							mo.momz = 9*FRACUNIT
							damageObject(atarget)
							P_StartQuake(FRACUNIT*12, 5)
							playSound(mo.battlen, sfx_phys)
							S_StartSound(mo, sfx_s3k96)
							for i = 1, 2
								createSplat(mo)
							end
						end
					elseif (timer >= 50)
					and mo.momz < -8*FRACUNIT
						return true
					end
				end,
	}

attackDefs["frankdance"] = {
		name = "Dance Off",
		type = ATK_PIERCE,
		power = 100,
		accuracy = 90,
		critical = 10,
		target = TGT_ENEMY,
		costtype = CST_SP,
		cost = 10,
		desc = "Challenge an enemy to a dance\noff! (May cause grooviness.)",
		anim_norepel = true,
		physical = true,
		anim = function(mo, targets, hittargets, timer)
					local target = targets[1]
					local atarget = hittargets[1]
					if (timer == 1)
						ANIM_set(mo, mo.anim_move, true)
						mo.reachedtarget = false
						mo.canjump = true
						mo.dover = true
						local an = target.angle + 45*ANG1

						local cx = target.x + 384*cos(an)
						local cy = target.y + 384*sin(an)

						CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, server.P_BattleStatus[mo.battlen].cam.z, 70*FRACUNIT)
						CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y), ANG1*4)
						S_StartSound(mo, sfx_zoom)
					end					
					
					if (timer < 20)
						mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
						P_InstaThrust(mo, mo.angle, FRACUNIT*16)
					end
					if timer == 21 //jump.
						ANIM_set(mo, mo.anim_special2, true)
						S_StartSound(mo, sfx_frhorn)
						P_InstaThrust(mo, mo.angle, FRACUNIT*0)
					end
					
					if timer > 21 and timer < 100
						if P_IsObjectOnGround(target)
							target.momz = 3*FRACUNIT
						end
					end
					
					if (timer == 100)
						mo.momz = 30*FRACUNIT 
						ANIM_set(mo, mo.anim_hurt, true)
						mo.reachedtarget = true
						damageObject(atarget)
						playSound(mo.battlen, sfx_phys)
						P_StartQuake(FRACUNIT*7, 4)
						S_StartSound(mo, sfx_faddie)
						P_SpawnMobj(mo.x, mo.y, mo.z, MT_FADBOOM)
						for i = 1, 2
							createSplat(mo)
						end
						//the groove
						local dancechance = P_RandomRange(1, 100)
						if dancechance <= 78
							target.dancing = true
							BTL_logMessage(mo.battlen, "DAMN THEY GROOVIN")
							if #target.passiveskills
								target.passiveskills[#target.passiveskills+1] = "dancin"
								dprint("Passive ammended to PSV Table")
							else
								target.passiveskills = {"dancin"}
								dprint("No passives, skill is 1st passive.")
							end
						end
					end
					
					if (timer == 130)
						return true
					end
				end,
		critanim = function(mo, targets, hittargets, timer)
					local target = targets[1]
					local atarget = hittargets[1]
					if (timer == 1)
						ANIM_set(mo, mo.anim_move, true)
						mo.reachedtarget = false
						mo.canjump = true
						mo.dover = true
						local an = target.angle + 45*ANG1

						local cx = target.x + 384*cos(an)
						local cy = target.y + 384*sin(an)

						CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, server.P_BattleStatus[mo.battlen].cam.z, 70*FRACUNIT)
						CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y), ANG1*4)
						S_StartSound(mo, sfx_zoom)
					end					
					
					if (timer < 20)
						mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
						P_InstaThrust(mo, mo.angle, FRACUNIT*16)
					end
					
					if timer > 21 and timer < 100
						if P_IsObjectOnGround(target)
							target.momz = 3*FRACUNIT
						end
					end
					
					if timer == 21 //jump.
						ANIM_set(mo, mo.anim_special2, true)
						if (mo.skin  == "dummie")
							S_StartSound(mo, sfx_fadwow)
						else
							S_StartSound(mo, sfx_frhorn)
						end
						P_InstaThrust(mo, mo.angle, FRACUNIT*0)
					end
					
					if timer == 90 //uh oh
						S_StartSound(mo, sfx_s3k86)
					end
					
					if (timer == 120)
						ANIM_set(mo, mo.anim_hurt, true)
						mo.reachedtarget = true
						damageObject(atarget)
						playSound(mo.battlen, sfx_phys)					
						S_StartSoundAtVolume(mo, sfx_bkpoof, 200)
						if (mo.skin  == "frank")
							S_StartSound(mo, sfx_frpit)
						end
						for i = 1, 2
							createSplat(mo)
						end
						//the groove
						local dancechance = P_RandomRange(1, 100)
						if dancechance <= 78
							target.dancing = true
							BTL_logMessage(mo.battlen, "DAMN THEY GROOVIN")
							if #target.passiveskills
								target.passiveskills[#target.passiveskills+1] = "dancin"
								dprint("Passive ammended to PSV Table")
							else
								target.passiveskills = {"dancin"}
								dprint("No passives, skill is 1st passive.")
							end
						end
					end
					
					if timer > 119 and timer < 160
						for i = 1, 12
							local boom = P_SpawnMobj(mo.x + P_RandomRange(-48, 48)*FRACUNIT, mo.y + P_RandomRange(-48, 48)*FRACUNIT, mo.z, MT_DUMMY)
							boom.state = S_QUICKBOOM1
							boom.momz = P_RandomRange(0, 48)*FRACUNIT
							boom.scale = FRACUNIT*3/2
							P_StartQuake(FRACUNIT*7, 4)
							
						end
					end
					
					if timer == 160
						ANIM_set(mo, mo.anim_special3, true)
						for i = 1, 32
							local smoke = P_SpawnMobj(mo.x + P_RandomRange(-48, 48)*FRACUNIT, mo.y + P_RandomRange(-48, 48)*FRACUNIT, mo.z + P_RandomRange(0, 128)*FRACUNIT, MT_SMOKE)
							smoke.scale = FRACUNIT*4
							smoke.momz = P_RandomRange(3, 10)*FRACUNIT
						end
					end
					
					if (timer == 190)
						return true
					end
				end,
	}
	
attackDefs["dancin"] = {
        name = "dancin",
        type = ATK_PASSIVE,
        desc = "funny 1.25 dmg when groovin",
        passive = PSV_TRIGGERDAMAGE_RECEIVED,
        anim =     function(mo, attacker, dmg, crit)
            if mo.damagestate ~= DMG_MISS
            and mo.damagestate ~= DMG_BLOCK
            and mo.damagestate ~= DMG_DRAIN
            and mo.dancing
                dmg = $*125/100
                mo.dancing = false
            end
            return dmg
        end,
    }
	
local function inthegroove(mo)
    if mo.dancing
        if P_IsObjectOnGround(mo)
			mo.momz = 3*FRACUNIT
			local dancenote = P_SpawnMobjFromMobj(mo, 0,0,2*FRACUNIT, MT_FADNOTE)
			dancenote.colorized = true
			if mo.color != 0
				dancenote.color = ColorOpposite(mo.color)
			else
				dancenote.color = SKINCOLOR_KETCHUP		
			end
			if mo.dancing == false return end
		end
    end
end
addHook("MobjThinker", inthegroove, MT_PFIGHTER)

//i've never heard of this at all
if bionis
    personaList["Frank"].weak = $|ATK_POISON
	personaList["Dummie"].resist = $|ATK_WATER
end	

weaponsList["franksneak"] = {
		name = "Brown Boots",
		type = WPT_SHOES,
		atk = 300,
		desc = "Frank's go-to boots.\nNice and cozy!",
		slot = "mastery 1",
		rarity = 1,
}